Index: sasmodels/generate.py
===================================================================
--- sasmodels/generate.py	(revision e66c9f9bddfbf0bb75d5d64484195eaf6802ca82)
+++ sasmodels/generate.py	(revision eafc9fa8b200a3b754e7dafb960c8891361eacef)
@@ -7,5 +7,5 @@
     particular dimensions averaged over all orientations.
 
-    *Iqxy(qx, qy, p1, p2, ...)* returns the scattering at qx,qy for a form
+    *Iqxy(qx, qy, p1, p2, ...)* returns the scattering at qx, qy for a form
     with particular dimensions for a single orientation.
 
@@ -47,5 +47,5 @@
 the *sin* and *cos* values are needed for a particular argument.  Since
 this function does not exist in C99, all use of *sincos* should be
-replaced by the macro *SINCOS(value,sn,cn)* where *sn* and *cn* are
+replaced by the macro *SINCOS(value, sn, cn)* where *sn* and *cn* are
 previously declared *double* variables.  When compiled for systems without
 OpenCL, *SINCOS* will be replaced by *sin* and *cos* calls.   If *value* is
@@ -194,8 +194,7 @@
 returns a list of files required by the model.
 """
+from __future__ import print_function
 
 # TODO: identify model files which have changed since loading and reload them.
-
-__all__ = ["make", "doc", "sources", "convert_type"]
 
 import sys
@@ -206,4 +205,7 @@
 
 import numpy as np
+
+__all__ = ["make", "doc", "sources", "convert_type"]
+
 C_KERNEL_TEMPLATE_PATH = joinpath(dirname(__file__), 'kernel_template.c')
 
@@ -216,5 +218,4 @@
     F128 = None
 
-
 # Scale and background, which are parameters common to every form factor
 COMMON_PARAMETERS = [
@@ -222,5 +223,4 @@
     ["background", "1/cm", 0, [0, np.inf], "", "Source background"],
     ]
-
 
 # Conversion from units defined in the parameter table for each model
@@ -266,4 +266,7 @@
 
 def format_units(units):
+    """
+    Convert units into ReStructured Text format.
+    """
     return "string" if isinstance(units, list) else RST_UNITS.get(units, units)
 
@@ -310,5 +313,5 @@
     raise ValueError("%r not found in %s" % (filename, search_path))
 
-def sources(info):
+def model_sources(info):
     """
     Return a list of the sources file paths for the module.
@@ -335,4 +338,7 @@
     """
     Convert code from double precision to the desired type.
+
+    Floating point constants are tagged with 'f' for single precision or 'L'
+    for long double precision.
     """
     if dtype == F16:
@@ -350,4 +356,8 @@
 
 def _convert_type(source, type_name, constant_flag):
+    """
+    Replace 'double' with *type_name* in *source*, tagging floating point
+    constants with *constant_flag*.
+    """
     # Convert double keyword to float/long double/half.
     # Accept an 'n' # parameter for vector # values, where n is 2, 4, 8 or 16.
@@ -363,9 +373,9 @@
 
 
-def kernel_name(info, is_2D):
+def kernel_name(info, is_2d):
     """
     Name of the exported kernel symbol.
     """
-    return info['name'] + "_" + ("Iqxy" if is_2D else "Iq")
+    return info['name'] + "_" + ("Iqxy" if is_2d else "Iq")
 
 
@@ -410,15 +420,15 @@
 
 
-def build_polydispersity_loops(pd_pars):
-    """
-    Build polydispersity loops
-
-    Returns loop opening and loop closing
-    """
-    LOOP_OPEN = """\
+LOOP_OPEN = """\
 for (int %(name)s_i=0; %(name)s_i < N%(name)s; %(name)s_i++) {
   const double %(name)s = loops[2*(%(name)s_i%(offset)s)];
   const double %(name)s_w = loops[2*(%(name)s_i%(offset)s)+1];\
 """
+def build_polydispersity_loops(pd_pars):
+    """
+    Build polydispersity loops
+
+    Returns loop opening and loop closing
+    """
     depth = 4
     offset = ""
@@ -455,5 +465,5 @@
 
     # Load additional sources
-    source = [open(f).read() for f in sources(info)]
+    source = [open(f).read() for f in model_sources(info)]
 
     # Prepare defines
@@ -563,9 +573,9 @@
 
     #for d in defines: print(d)
-    DEFINES = '\n'.join('#define %s %s' % (k, v) for k, v in defines)
-    SOURCES = '\n\n'.join(source)
+    defines = '\n'.join('#define %s %s' % (k, v) for k, v in defines)
+    sources = '\n\n'.join(source)
     return C_KERNEL_TEMPLATE % {
-        'DEFINES':DEFINES,
-        'SOURCES':SOURCES,
+        'DEFINES': defines,
+        'SOURCES': sources,
         }
 
@@ -581,5 +591,5 @@
     demo_parameters = getattr(kernel_module, 'demo', None)
     if demo_parameters is None:
-        demo_parameters = dict((p[0],p[2]) for p in parameters)
+        demo_parameters = dict((p[0], p[2]) for p in parameters)
     filename = abspath(kernel_module.__file__)
     kernel_id = splitext(basename(filename))[0]
@@ -588,5 +598,5 @@
         name = " ".join(w.capitalize() for w in kernel_id.split('_'))
     info = dict(
-        id = kernel_id,  # string used to load the kernel
+        id=kernel_id,  # string used to load the kernel
         filename=abspath(kernel_module.__file__),
         name=name,
@@ -625,4 +635,7 @@
                             %re.escape(string.punctuation))
 def _convert_section_titles_to_boldface(lines):
+    """
+    Do the actual work of identifying and converting section headings.
+    """
     prior = None
     for line in lines:
@@ -631,5 +644,5 @@
         elif section_marker.match(line):
             if len(line) >= len(prior):
-                yield "".join( ("**",prior,"**") )
+                yield "".join(("**", prior, "**"))
                 prior = None
             else:
@@ -642,6 +655,13 @@
         yield prior
 
-def convert_section_titles_to_boldface(string):
-    return "\n".join(_convert_section_titles_to_boldface(string.split('\n')))
+def convert_section_titles_to_boldface(s):
+    """
+    Use explicit bold-face rather than section headings so that the table of
+    contents is not polluted with section names from the model documentation.
+
+    Sections are identified as the title line followed by a line of punctuation
+    at least as long as the title line.
+    """
+    return "\n".join(_convert_section_titles_to_boldface(s.split('\n')))
 
 def doc(kernel_module):
@@ -666,4 +686,7 @@
 
 def demo_time():
+    """
+    Show how long it takes to process a model.
+    """
     from .models import cylinder
     import datetime
@@ -674,4 +697,7 @@
 
 def main():
+    """
+    Program which prints the source produced by the model.
+    """
     if len(sys.argv) <= 1:
         print("usage: python -m sasmodels.generate modelname")
Index: sasmodels/kernel_template.c
===================================================================
--- sasmodels/kernel_template.c	(revision 9c79c32da6740e2bbac1a67d4d4794a71533de93)
+++ sasmodels/kernel_template.c	(revision 840b85918586f724a23f78252f90ed33ac27fdf7)
@@ -16,10 +16,38 @@
      using namespace std;
      #if defined(_MSC_VER)
-     #   define kernel extern "C" __declspec( dllexport )
+         #include <limits>
+         #include <float.h>
+         #define kernel extern "C" __declspec( dllexport )
          inline double trunc(double x) { return x>=0?floor(x):-floor(-x); }
-	 inline double fmin(double x, double y) { return x>y ? y : x; }
-	 inline double fmax(double x, double y) { return x<y ? y : x; }
+	     inline double fmin(double x, double y) { return x>y ? y : x; }
+	     inline double fmax(double x, double y) { return x<y ? y : x; }
+	     inline double isnan(double x) { return _isnan(x); }
+	     #define NAN (std::numeric_limits<double>::quiet_NaN()) // non-signalling NaN
+	     static double cephes_expm1(double x) {
+	         // Adapted from the cephes math library.
+	         // Copyright 1984 - 1992 by Stephen L. Moshier
+	         if (x != x || x == 0.0) {
+	             return x; // NaN and +/- 0
+	         } else if (x < -0.5 || x > 0.5) {
+	             return exp(x) - 1.0;
+	         } else {
+	             const double xsq = x*x;
+	             const double p = (((
+	                  +1.2617719307481059087798E-4)*xsq
+                      +3.0299440770744196129956E-2)*xsq
+                      +9.9999999999999999991025E-1);
+                 const double q = ((((
+                      +3.0019850513866445504159E-6)*xsq
+                      +2.5244834034968410419224E-3)*xsq
+                      +2.2726554820815502876593E-1)*xsq
+                      +2.0000000000000000000897E0);
+                 double r = x * p;
+	             r =  r / (q - r);
+	             return r+r;
+	         }
+	     }
+	     #define expm1 cephes_expm1
      #else
-     #   define kernel extern "C"
+         #define kernel extern "C"
      #endif
      inline void SINCOS(double angle, double &svar, double &cvar) { svar=sin(angle); cvar=cos(angle); }
Index: sasmodels/kernelcl.py
===================================================================
--- sasmodels/kernelcl.py	(revision cde11f0f857d1861f37ded681777699e3aa91738)
+++ sasmodels/kernelcl.py	(revision e6a5556cf35ef5c00c42dc56786102efc2b7d5c1)
@@ -1,4 +1,4 @@
 """
-GPU support through OpenCL
+GPU driver for C kernels
 
 There should be a single GPU environment running on the system.  This
@@ -152,10 +152,4 @@
 
 
-def make_result(self, size):
-    self.res = np.empty(size, dtype=self.dtype)
-    self.res_b = cl.Buffer(self.program.context, mf.READ_WRITE, self.res.nbytes)
-    return self.res, self.res_b
-
-
 # for now, this returns one device in the context
 # TODO: create a context that contains all devices on all platforms
@@ -178,15 +172,41 @@
         #self.data_boundary = max(d.min_data_type_align_size
         #                         for d in self.context.devices)
-        self.queues = [cl.CommandQueue(self.context, d)
-                       for d in self.context.devices]
+        self.queues = [cl.CommandQueue(context, context.devices[0])
+                       for context in self.context]
         self.compiled = {}
 
     def has_type(self, dtype):
+        """
+        Return True if all devices support a given type.
+        """
         dtype = generate.F32 if dtype == 'fast' else np.dtype(dtype)
-        return all(has_type(d, dtype) for d in self.context.devices)
+        return any(has_type(d, dtype)
+                   for context in self.context
+                   for d in context.devices)
+
+    def get_queue(self, dtype):
+        """
+        Return a command queue for the kernels of type dtype.
+        """
+        for context, queue in zip(self.context, self.queues):
+            if all(has_type(d, dtype) for d in context.devices):
+                return queue
+
+    def get_context(self, dtype):
+        """
+        Return a OpenCL context for the kernels of type dtype.
+        """
+        for context, queue in zip(self.context, self.queues):
+            if all(has_type(d, dtype) for d in context.devices):
+                return context
 
     def _create_some_context(self):
+        """
+        Protected call to cl.create_some_context without interactivity.  Use
+        this if PYOPENCL_CTX is set in the environment.  Sets the *context*
+        attribute.
+        """
         try:
-            self.context = cl.create_some_context(interactive=False)
+            self.context = [cl.create_some_context(interactive=False)]
         except Exception as exc:
             warnings.warn(str(exc))
@@ -195,13 +215,19 @@
 
     def compile_program(self, name, source, dtype, fast=False):
+        """
+        Compile the program for the device in the given context.
+        """
         key = "%s-%s-%s"%(name, dtype, fast)
         if key not in self.compiled:
             #print("compiling",name)
             dtype = np.dtype(dtype)
-            program = compile_model(self.context, source, dtype, fast)
+            program = compile_model(self.get_context(dtype), source, dtype, fast)
             self.compiled[key] = program
         return self.compiled[key]
 
     def release_program(self, name):
+        """
+        Free memory associated with the program on the device.
+        """
         if name in self.compiled:
             self.compiled[name].release()
@@ -209,16 +235,52 @@
 
 def _get_default_context():
-    default = None
+    """
+    Get an OpenCL context, preferring GPU over CPU, and preferring Intel
+    drivers over AMD drivers.
+    """
+    # Note: on mobile devices there is automatic clock scaling if either the
+    # CPU or the GPU is underutilized; probably doesn't affect us, but we if
+    # it did, it would mean that putting a busy loop on the CPU while the GPU
+    # is running may increase throughput.
+    #
+    # Macbook pro, base install:
+    #     {'Apple': [Intel CPU, NVIDIA GPU]}
+    # Macbook pro, base install:
+    #     {'Apple': [Intel CPU, Intel GPU]}
+    # 2 x nvidia 295 with Intel and NVIDIA opencl drivers installed
+    #     {'Intel': [CPU], 'NVIDIA': [GPU, GPU, GPU, GPU]}
+    gpu, cpu = None, None
     for platform in cl.get_platforms():
+        # AMD provides a much weaker CPU driver than Intel/Apple, so avoid it.
+        # If someone has bothered to install the AMD/NVIDIA drivers, prefer them over the integrated
+        # graphics driver that may have been supplied with the CPU chipset.
+        preferred_cpu = platform.vendor.startswith('Intel') or platform.vendor.startswith('Apple')
+        preferred_gpu = platform.vendor.startswith('Advanced') or platform.vendor.startswith('NVIDIA')
         for device in platform.get_devices():
             if device.type == cl.device_type.GPU:
-                return cl.Context([device])
-            if default is None:
-                default = device
-
-    if not default:
-        raise RuntimeError("OpenCL device not found")
-
-    return cl.Context([default])
+                # If the existing type is not GPU then it will be CUSTOM or ACCELERATOR,
+                # so don't override it.
+                if gpu is None or (preferred_gpu and gpu.type == cl.device_type.GPU):
+                    gpu = device
+            elif device.type == cl.device_type.CPU:
+                if cpu is None or preferred_cpu:
+                    cpu = device
+            else:
+                # System has cl.device_type.ACCELERATOR or cl.device_type.CUSTOM
+                # Intel Phi for example registers as an accelerator
+                # Since the user installed a custom device on their system and went through the
+                # pain of sorting out OpenCL drivers for it, lets assume they really do want to
+                # use it as their primary compute device.
+                gpu = device
+
+    # order the devices by gpu then by cpu; when searching for an available device by data type they
+    # will be checked in this order, which means that if the gpu supports double then the cpu will never
+    # be used (though we may make it possible to explicitly request the cpu at some point).
+    devices = []
+    if gpu is not None:
+        devices.append(gpu)
+    if cpu is not None:
+        devices.append(cpu)
+    return [cl.Context([d]) for d in devices]
 
 
@@ -241,42 +303,35 @@
         self.info = info
         self.source = source
-        self.dtype = generate.F32 if dtype=='fast' else np.dtype(dtype)
+        self.dtype = generate.F32 if dtype == 'fast' else np.dtype(dtype)
         self.fast = (dtype == 'fast')
         self.program = None # delay program creation
 
     def __getstate__(self):
-        state = self.__dict__.copy()
-        state['program'] = None
-        return state
+        return self.info, self.source, self.dtype, self.fast
 
     def __setstate__(self, state):
-        self.__dict__ = state.copy()
-
-    def __call__(self, q_input):
-        if self.dtype != q_input.dtype:
-            raise TypeError("data is %s kernel is %s"
-                            % (q_input.dtype, self.dtype))
+        self.info, self.source, self.dtype, self.fast = state
+        self.program = None
+
+    def __call__(self, q_vectors):
         if self.program is None:
             compiler = environment().compile_program
             self.program = compiler(self.info['name'], self.source, self.dtype,
                                     self.fast)
-        kernel_name = generate.kernel_name(self.info, q_input.is_2D)
+        is_2d = len(q_vectors) == 2
+        kernel_name = generate.kernel_name(self.info, is_2d)
         kernel = getattr(self.program, kernel_name)
-        return GpuKernel(kernel, self.info, q_input)
+        return GpuKernel(kernel, self.info, q_vectors, self.dtype)
 
     def release(self):
+        """
+        Free the resources associated with the model.
+        """
         if self.program is not None:
             environment().release_program(self.info['name'])
             self.program = None
 
-    def make_input(self, q_vectors):
-        """
-        Make q input vectors available to the model.
-
-        Note that each model needs its own q vector even if the case of
-        mixture models because some models may be OpenCL, some may be
-        ctypes and some may be pure python.
-        """
-        return GpuInput(q_vectors, dtype=self.dtype)
+    def __del__(self):
+        self.release()
 
 # TODO: check that we don't need a destructor for buffers which go out of scope
@@ -304,5 +359,5 @@
         self.nq = q_vectors[0].size
         self.dtype = np.dtype(dtype)
-        self.is_2D = (len(q_vectors) == 2)
+        self.is_2d = (len(q_vectors) == 2)
         # TODO: stretch input based on get_warp()
         # not doing it now since warp depends on kernel, which is not known
@@ -310,6 +365,7 @@
         # architectures tested so far.
         self.q_vectors = [_stretch_input(q, self.dtype, 32) for q in q_vectors]
+        context = env.get_context(self.dtype)
         self.q_buffers = [
-            cl.Buffer(env.context, mf.READ_ONLY | mf.COPY_HOST_PTR, hostbuf=q)
+            cl.Buffer(context, mf.READ_ONLY | mf.COPY_HOST_PTR, hostbuf=q)
             for q in self.q_vectors
         ]
@@ -317,18 +373,25 @@
 
     def release(self):
+        """
+        Free the memory.
+        """
         for b in self.q_buffers:
             b.release()
         self.q_buffers = []
 
+    def __del__(self):
+        self.release()
+
 class GpuKernel(object):
     """
     Callable SAS kernel.
 
-    *kernel* is the GpuKernel object to call.
+    *kernel* is the GpuKernel object to call
 
     *info* is the module information
 
-    *q_input* is the DllInput q vectors at which the kernel should be
-    evaluated.
+    *q_vectors* is the q vectors at which the kernel should be evaluated
+
+    *dtype* is the kernel precision
 
     The resulting call method takes the *pars*, a list of values for
@@ -340,10 +403,10 @@
     Call :meth:`release` when done with the kernel instance.
     """
-    def __init__(self, kernel, info, q_input):
-        self.q_input = q_input
+    def __init__(self, kernel, info, q_vectors, dtype):
+        q_input = GpuInput(q_vectors, dtype)
         self.kernel = kernel
         self.info = info
         self.res = np.empty(q_input.nq, q_input.dtype)
-        dim = '2d' if q_input.is_2D else '1d'
+        dim = '2d' if q_input.is_2d else '1d'
         self.fixed_pars = info['partype']['fixed-' + dim]
         self.pd_pars = info['partype']['pd-' + dim]
@@ -352,11 +415,12 @@
         # Note: res may be shorter than res_b if global_size != nq
         env = environment()
-        self.loops_b = [cl.Buffer(env.context, mf.READ_WRITE,
-                                  2 * MAX_LOOPS * q_input.dtype.itemsize)
-                        for _ in env.queues]
-        self.res_b = [cl.Buffer(env.context, mf.READ_WRITE,
-                                q_input.global_size[0] * q_input.dtype.itemsize)
-                      for _ in env.queues]
-
+        self.queue = env.get_queue(dtype)
+        self.loops_b = cl.Buffer(self.queue.context, mf.READ_WRITE,
+                                 2 * MAX_LOOPS * q_input.dtype.itemsize)
+        self.res_b = cl.Buffer(self.queue.context, mf.READ_WRITE,
+                               q_input.global_size[0] * q_input.dtype.itemsize)
+        self.q_input = q_input
+
+        self._need_release = [self.loops_b, self.res_b, self.q_input]
 
     def __call__(self, fixed_pars, pd_pars, cutoff=1e-5):
@@ -366,7 +430,5 @@
                 else np.float32)  # will never get here, so use np.float32
 
-        device_num = 0
-        queuei = environment().queues[device_num]
-        res_bi = self.res_b[device_num]
+        res_bi = self.res_b
         nq = np.uint32(self.q_input.nq)
         if pd_pars:
@@ -383,6 +445,6 @@
                 raise ValueError("too many polydispersity points")
 
-            loops_bi = self.loops_b[device_num]
-            cl.enqueue_copy(queuei, loops_bi, loops)
+            loops_bi = self.loops_b
+            cl.enqueue_copy(self.queue, loops_bi, loops)
             loops_l = cl.LocalMemory(len(loops.data))
             #ctx = environment().context
@@ -393,16 +455,16 @@
         fixed = [real(p) for p in fixed_pars]
         args = self.q_input.q_buffers + [res_bi, nq] + dispersed + fixed
-        self.kernel(queuei, self.q_input.global_size, None, *args)
-        cl.enqueue_copy(queuei, self.res, res_bi)
+        self.kernel(self.queue, self.q_input.global_size, None, *args)
+        cl.enqueue_copy(self.queue, self.res, res_bi)
 
         return self.res
 
     def release(self):
-        for b in self.loops_b:
-            b.release()
-        self.loops_b = []
-        for b in self.res_b:
-            b.release()
-        self.res_b = []
+        """
+        Release resources associated with the kernel.
+        """
+        for v in self._need_release:
+            v.release()
+        self._need_release = []
 
     def __del__(self):
Index: sasmodels/kerneldll.py
===================================================================
--- sasmodels/kerneldll.py	(revision 74667d322dd33e8f42805e77bc688d1a9a99b4fa)
+++ sasmodels/kerneldll.py	(revision eafc9fa8b200a3b754e7dafb960c8891361eacef)
@@ -1,4 +1,4 @@
 r"""
-C types wrapper for sasview models.
+DLL driver for C kernels
 
 The global attribute *ALLOW_SINGLE_PRECISION_DLLS* should be set to *True* if
@@ -44,4 +44,5 @@
 directory for this application, then OpenMP should be supported.
 """
+from __future__ import print_function
 
 import sys
@@ -122,5 +123,5 @@
     models are allowed as DLLs.
     """
-    if callable(info.get('Iq',None)):
+    if callable(info.get('Iq', None)):
         return PyModel(info)
 
@@ -139,11 +140,11 @@
 
     source = generate.convert_type(source, dtype)
-    source_files = generate.sources(info) + [info['filename']]
-    dll= dll_path(info, dtype)
+    source_files = generate.model_sources(info) + [info['filename']]
+    dll = dll_path(info, dtype)
     newest = max(os.path.getmtime(f) for f in source_files)
-    if not os.path.exists(dll) or os.path.getmtime(dll)<newest:
+    if not os.path.exists(dll) or os.path.getmtime(dll) < newest:
         # Replace with a proper temp file
-        fid, filename = tempfile.mkstemp(suffix=".c",prefix=tempfile_prefix)
-        os.fdopen(fid,"w").write(source)
+        fid, filename = tempfile.mkstemp(suffix=".c", prefix=tempfile_prefix)
+        os.fdopen(fid, "w").write(source)
         command = COMPILE%{"source":filename, "output":dll}
         print("Compile command: "+command)
@@ -160,5 +161,5 @@
 def load_dll(source, info, dtype="double"):
     """
-    Create and load a dll corresponding to the source,info pair returned
+    Create and load a dll corresponding to the source, info pair returned
     from :func:`sasmodels.generate.make` compiled for the target precision.
 
@@ -199,5 +200,5 @@
         Npd2d = len(self.info['partype']['pd-2d'])
 
-        #print("dll",self.dllpath)
+        #print("dll", self.dllpath)
         try:
             self.dll = ct.CDLL(self.dllpath)
@@ -210,5 +211,5 @@
               else c_longdouble)
         pd_args_1d = [c_void_p, fp] + [c_int]*Npd1d if Npd1d else []
-        pd_args_2d= [c_void_p, fp] + [c_int]*Npd2d if Npd2d else []
+        pd_args_2d = [c_void_p, fp] + [c_int]*Npd2d if Npd2d else []
         self.Iq = self.dll[generate.kernel_name(self.info, False)]
         self.Iq.argtypes = IQ_ARGS + pd_args_1d + [fp]*Nfixed1d
@@ -218,28 +219,20 @@
 
     def __getstate__(self):
-        return {'info': self.info, 'dllpath': self.dllpath, 'dll': None}
+        return self.info, self.dllpath
 
     def __setstate__(self, state):
-        self.__dict__ = state
-
-    def __call__(self, q_input):
-        if self.dtype != q_input.dtype:
-            raise TypeError("data is %s kernel is %s" % (q_input.dtype, self.dtype))
+        self.info, self.dllpath = state
+        self.dll = None
+
+    def __call__(self, q_vectors):
+        q_input = PyInput(q_vectors, self.dtype)
         if self.dll is None: self._load_dll()
-        kernel = self.Iqxy if q_input.is_2D else self.Iq
+        kernel = self.Iqxy if q_input.is_2d else self.Iq
         return DllKernel(kernel, self.info, q_input)
 
-    # pylint: disable=no-self-use
-    def make_input(self, q_vectors):
-        """
-        Make q input vectors available to the model.
-
-        Note that each model needs its own q vector even if the case of
-        mixture models because some models may be OpenCL, some may be
-        ctypes and some may be pure python.
-        """
-        return PyInput(q_vectors, dtype=self.dtype)
-
     def release(self):
+        """
+        Release any resources associated with the model.
+        """
         pass # TODO: should release the dll
 
@@ -257,5 +250,5 @@
 
     The resulting call method takes the *pars*, a list of values for
-    the fixed parameters to the kernel, and *pd_pars*, a list of (value,weight)
+    the fixed parameters to the kernel, and *pd_pars*, a list of (value, weight)
     vectors for the polydisperse parameters.  *cutoff* determines the
     integration limits: any points with combined weight less than *cutoff*
@@ -269,5 +262,5 @@
         self.kernel = kernel
         self.res = np.empty(q_input.nq, q_input.dtype)
-        dim = '2d' if q_input.is_2D else '1d'
+        dim = '2d' if q_input.is_2d else '1d'
         self.fixed_pars = info['partype']['fixed-'+dim]
         self.pd_pars = info['partype']['pd-'+dim]
@@ -299,3 +292,6 @@
 
     def release(self):
+        """
+        Release any resources associated with the kernel.
+        """
         pass
Index: sasmodels/kernelpy.py
===================================================================
--- sasmodels/kernelpy.py	(revision 4c2c535bfe4a2a460e9aaf4ef0ed8b22d96965fd)
+++ sasmodels/kernelpy.py	(revision eafc9fa8b200a3b754e7dafb960c8891361eacef)
@@ -1,2 +1,10 @@
+"""
+Python driver for python kernels
+
+Calls the kernel with a vector of $q$ values for a single parameter set.
+Polydispersity is supported by looping over different parameter sets and
+summing the results.  The interface to :class:`PyModel` matches those for
+:class:`kernelcl.GpuModel` and :class:`kerneldll.DllModel`.
+"""
 import numpy as np
 from numpy import pi, cos
@@ -5,16 +13,19 @@
 
 class PyModel(object):
+    """
+    Wrapper for pure python models.
+    """
     def __init__(self, info):
         self.info = info
 
-    def __call__(self, q_input):
-        kernel = self.info['Iqxy'] if q_input.is_2D else self.info['Iq']
+    def __call__(self, q_vectors):
+        q_input = PyInput(q_vectors, dtype=F64)
+        kernel = self.info['Iqxy'] if q_input.is_2d else self.info['Iq']
         return PyKernel(kernel, self.info, q_input)
 
-    # pylint: disable=no-self-use
-    def make_input(self, q_vectors):
-        return PyInput(q_vectors, dtype=F64)
-
     def release(self):
+        """
+        Free resources associated with the model.
+        """
         pass
 
@@ -41,9 +52,12 @@
         self.nq = q_vectors[0].size
         self.dtype = dtype
-        self.is_2D = (len(q_vectors) == 2)
+        self.is_2d = (len(q_vectors) == 2)
         self.q_vectors = [np.ascontiguousarray(q, self.dtype) for q in q_vectors]
         self.q_pointers = [q.ctypes.data for q in self.q_vectors]
 
     def release(self):
+        """
+        Free resources associated with the model inputs.
+        """
         self.q_vectors = []
 
@@ -71,5 +85,5 @@
         self.q_input = q_input
         self.res = np.empty(q_input.nq, q_input.dtype)
-        dim = '2d' if q_input.is_2D else '1d'
+        dim = '2d' if q_input.is_2d else '1d'
         # Loop over q unless user promises that the kernel is vectorized by
         # taggining it with vectorized=True
@@ -77,8 +91,14 @@
             if dim == '2d':
                 def vector_kernel(qx, qy, *args):
+                    """
+                    Vectorized 2D kernel.
+                    """
                     return np.array([kernel(qxi, qyi, *args)
                                      for qxi, qyi in zip(qx, qy)])
             else:
                 def vector_kernel(q, *args):
+                    """
+                    Vectorized 1D kernel.
+                    """
                     return np.array([kernel(qi, *args)
                                      for qi in q])
@@ -122,4 +142,7 @@
 
     def release(self):
+        """
+        Free resources associated with the kernel.
+        """
         self.q_input = None
 
Index: sasmodels/list_pars.py
===================================================================
--- sasmodels/list_pars.py	(revision 5c962dff13d0a0a2f6d779be8df775f540958dbc)
+++ sasmodels/list_pars.py	(revision 5c962dff13d0a0a2f6d779be8df775f540958dbc)
@@ -0,0 +1,63 @@
+"""
+List all parameters used along with the models which use them.
+
+Usage:
+
+    python -m sasmodels.list_pars [-v]
+
+If '-v' is given, then list the models containing the parameter in
+addition to just the parameter name.
+"""
+from __future__ import print_function
+
+import sys
+
+from .core import load_model_definition
+from .generate import make_info
+from .compare import MODELS, columnize
+
+def find_pars():
+    """
+    Find all parameters in all models.
+
+    Returns the reference table *{parameter: [model, model, ...]}*
+    """
+    partable = {}
+    for name in sorted(MODELS):
+        definition = load_model_definition(name)
+        info = make_info(definition)
+        for p in info['parameters']:
+            pname = p[0]
+            partable.setdefault(pname, [])
+            partable[pname].append(name)
+    return partable
+
+def list_pars(names_only=True):
+    """
+    Print all parameters in all models.
+
+    If *names_only* then only print the parameter name, not the models it
+    occurs in.
+    """
+    partable = find_pars()
+    if names_only:
+        print(columnize(list(sorted(partable.keys()))))
+    else:
+        for k, v in sorted(partable.items()):
+            print("%s: %s"%(k, ", ".join(v)))
+
+def main():
+    """
+    Program to list the parameters used across all models.
+    """
+    if len(sys.argv) == 2 and sys.argv[1] == '-v':
+        verbose = True
+    elif len(sys.argv) == 1:
+        verbose = False
+    else:
+        print(__doc__)
+        sys.exit(1)
+    list_pars(names_only=not verbose)
+
+if __name__ == "__main__":
+    main()
